/*  sched.c
 *
 *  sched.c,v 1.3 1995/12/19 20:01:40 joel Exp
 */

#include <sched.h>
#include <rtems/score/tod.h>
#include <rtems/score/thread.h>
#include <rtems/posix/priority.h>

#ifdef NOT_IMPLEMENTED_YET

/*PAGE
 *
 *  13.3.1 Set Scheduling Parameters, P1003.1b-1993, p. 252
 *
 */

int sched_setparam(
  pid_t                     pid,
  const struct sched_param *param
)
{
  return POSIX_NOT_IMPLEMENTED();
}

/*PAGE
 *
 *  13.3.2 Set Scheduling Parameters, P1003.1b-1993, p. 253
 */

int sched_getparam(
  pid_t                     pid,
  const struct sched_param *param
)
{
  return POSIX_NOT_IMPLEMENTED();
}

/*PAGE
 *
 *  13.3.3 Set Scheduling Policy and Scheduling Parameters, 
 *         P1003.1b-1993, p. 254
 */

int sched_setscheduler(
  pid_t                     pid,
  int                       policy,
  const struct sched_param *param
)
{
  return POSIX_NOT_IMPLEMENTED();
}

/*PAGE
 *
 *  13.3.4 Get Scheduling Policy, P1003.1b-1993, p. 256
 */

int sched_getscheduler(
  pid_t                     pid
)
{
  return POSIX_NOT_IMPLEMENTED();
}

#endif

/*PAGE
 *
 *  13.3.6 Get Scheduling Parameter Limits, P1003.1b-1993, p. 258
 */

int sched_get_priority_max(
  int  policy
)
{
  /* XXX error check the policy */
  return POSIX_SCHEDULER_MAXIMUM_PRIORITY;
}

/*PAGE
 *
 *  13.3.6 Get Scheduling Parameter Limits, P1003.1b-1993, p. 258
 */

int sched_get_priority_min(
  int  policy
)
{
  /* XXX error check the policy */
  return POSIX_SCHEDULER_MINIMUM_PRIORITY;
}

/*PAGE
 *
 *  13.3.6 Get Scheduling Parameter Limits, P1003.1b-1993, p. 258
 */

int sched_rr_get_interval(
  pid_t             pid,
  struct timespec  *interval
)
{
  time_t us_per_quantum; 

  /* XXX eventually should support different time quantums per thread */

  /* XXX should get for errors? (bad pid) */

  us_per_quantum = _TOD_Microseconds_per_tick * _Thread_Ticks_per_timeslice;

  interval->tv_sec  = us_per_quantum / TOD_MICROSECONDS_PER_SECOND;
  interval->tv_nsec = (us_per_quantum % TOD_MICROSECONDS_PER_SECOND) * 1000;
  return 0;
}

/*PAGE
 *
 *  13.3.5 Yield Processor, P1003.1b-1993, p. 257
 */

int sched_yield( void )
{
  _Thread_Yield_processor();
  return 0;
}
