/* sys/time.h
 *
 *  time.h,v 1.2 1995/10/06 20:46:50 joel Exp
 */

#ifndef __POSIX_SYS_TIME_h
#define __POSIX_SYS_TIME_h

#include <sys/types.h>

/*
 *  XXX: C Language Standard (placement follows Solaris)
 */

typedef int time_t;

/*
 *  14.1.1 Time Value Specification Structures, P1003.1b-1993, p. 261
 */

struct timespec {
  time_t  tv_sec;   /* Seconds */
  long    tv_nsec;  /* Nanoseconds */
};

struct itimerspec {
  struct timespec  it_interval;  /* Timer period */
  struct timespec  it_value;     /* Timer expiration */
};

/*
 *  14.1.3 Manifest Constants, P1003.1b-1993, p. 262
 */

#define CLOCK_REALTIME 0 /* identifier for the systemwide realtime clock */
#define TIME_ABSTIME   0 /* flag indicating time is "absolute" with respect */
                         /*   to the clock associated with a time */

/* XXX should really be ifdef'ed */

/*
 *  BSD based stuff
 */

struct timezone {
  int tz_minuteswest;
  int tz_dsttime;
};

struct timeval {
  int tv_sec;
  int tv_usec;
};

int gettimeofday(
  struct timeval  *tp,
  struct timezone *tzp
);

#endif
/* end of include */
