/*  intthrd.inl
 *
 *  This file contains the static inline implementation of all inlined
 *  routines in the with Internal Threads Handler.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  intthrd.inl,v 1.2 1995/12/19 20:02:23 joel Exp
 */

#ifndef __INTERNAL_THREADS_inl
#define __INTERNAL_THREADS_inl

/*PAGE
 *
 *  _Internal_threads_Allocate
 *
 */

STATIC INLINE Thread_Control *_Internal_threads_Allocate( void )
{
  return (Thread_Control *) _Objects_Allocate( &_Internal_threads_Information );
}

/*PAGE
 *
 *  _Internal_threads_Free
 *
 */

STATIC INLINE void _Internal_threads_Free (
  Thread_Control *the_task
)
{
  _Objects_Free( &_Internal_threads_Information, &the_task->Object );
}

#endif
/* end of include file */
