/*  io.inl
 *
 *  This file contains macro implementations for all of the inlined
 *  routines in the input/output manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  io.inl,v 1.4 1995/12/19 20:02:32 joel Exp
 */

#ifndef __IO_inl
#define __IO_inl

/*PAGE
 *
 *  _IO_Manager_initialization
 *
 */

#define _IO_Manager_initialization( \
  _driver_table, _number_of_drivers, _number_of_devices ) \
  do { \
    _IO_Driver_address_table = (_driver_table); \
    _IO_Number_of_drivers    = (_number_of_drivers); \
    _IO_Number_of_devices    = (_number_of_devices); \
    \
    _IO_Driver_name_table = _Workspace_Allocate_or_fatal_error( \
      sizeof( rtems_driver_name_t ) * ( (_number_of_devices) + 1 ) \
    ); \
  } while (0)

#endif
/* end of include file */
