/*  bsp_cleanup()
 *
 *  This routine cleans up in the sense that it places the board
 *  in a safe state and flushes the I/O buffers before exiting. 
 *
 *  INPUT:  NONE
 *
 *  OUTPUT: NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  bspclean.c,v 1.1 1995/09/20 15:05:10 joel Exp
 */

#include <bsp.h>

void bsp_cleanup(void)
{
    /* interrupt driven stdio must be flushed */
    _CPU_ISR_Set_level( 7 );
    _UART_flush();
}
