/*  Shm_Get_packet
 *
 *  This routine is the shared memory locked queue MPCI driver
 *  routine used to obtain an empty message packet.
 *
 *  Input parameters:
 *    packet             - address of pointer to packet
 *
 *  Output parameters:
 *    *(cpb->get_packet) - address of allocated packet
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  getpkt.c,v 1.3 1995/12/19 20:10:54 joel Exp
 */

#include <rtems.h>
#include "shm.h"

rtems_mpci_entry Shm_Get_packet(
  rtems_packet_prefix **packet
)
{
  Shm_Envelope_control *ecb;

  ecb = Shm_Allocate_envelope();
  if ( !ecb )
    rtems_fatal_error_occurred ( SHM_NO_FREE_PKTS );
  *packet = Shm_Envelope_control_to_packet_prefix_pointer( ecb );
}
