
/*
 *	@(#)error.h	1.3 - 95/10/25
 *	
 *
 *  Defines and externs for rtems error reporting
 *
 *  error.h,v 1.3 1996/01/15 21:50:06 joel Exp
 */

#ifndef __RTEMS_ERROR_h
#define __RTEMS_ERROR_h

/*
 * rtems_error() and rtems_panic() support
 */

#define RTEMS_ERROR_ERRNO  (1<<((sizeof(int) * 8) - 2)) /* hi bit; use 'errno' */
#define RTEMS_ERROR_PANIC  (RTEMS_ERROR_ERRNO / 2)       /* err fatal; no return */
#define RTEMS_ERROR_ABORT  (RTEMS_ERROR_ERRNO / 4)       /* err is fatal; panic */

#define RTEMS_ERROR_MASK  (RTEMS_ERROR_ERRNO | RTEMS_ERROR_ABORT | \
                             RTEMS_ERROR_PANIC) /* all */

const char *rtems_status_text(rtems_status_code);
int   rtems_error(int error_code, const char *printf_format, ...);
void  rtems_panic(const char *printf_format, ...);

extern int rtems_panic_in_progress;

#endif
/* end of include file */
