#define TEST_INIT
#include "system.h"

rtems_isr trap2ISR(rtems_vector_number vector) {
    rtems_status_code status;

    status = rtems_semaphore_release(
        semaphoreId[adcWait]
	);
    directive_failed( status, "rtems_semaphore_release");
}    

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_status_code status;
  rtems_isr_entry dummy;

  puts( "\n\n*** adc test ***" );

  status = rtems_interrupt_catch(
      trap2ISR,
      34,
      &dummy
      );
  directive_failed( status, "rtems_interrupt_catch");

  semaphoreName[1] = rtems_build_name( 'S', 'M', '1', ' ' );
  semaphoreName[2] = rtems_build_name( 'S', 'M', '2', ' ' );
/*   semaphoreName[3] = rtems_build_name( 'S', 'M', '3', ' ' ); */

  status = rtems_semaphore_create(
     semaphoreName[adcLock],
     1,
     RTEMS_PRIORITY | RTEMS_BINARY_SEMAPHORE | 
         RTEMS_NO_INHERIT_PRIORITY | RTEMS_NO_PRIORITY_CEILING | RTEMS_LOCAL,
     0,
     &semaphoreId[adcLock]
     );
  directive_failed( status, "semaphore_create of SM1");

  status = rtems_semaphore_create(
     semaphoreName[adcWait],
     0,
     RTEMS_DEFAULT_ATTRIBUTES,
     RTEMS_NO_PRIORITY,
     &semaphoreId[adcWait]
     );
  directive_failed( status, "semaphore_create of SM1");

  Task_name[ 1 ] = rtems_build_name( 'T', 'A', '1', ' ' );
  Task_name[ 2 ] = rtems_build_name( 'T', 'A', '2', ' ' );
  Task_name[ 3 ] = rtems_build_name( 'T', 'A', '3', ' ' );
  Task_name[ 4 ] = rtems_build_name( 'k', 'e', 'y', ' ' );

  status = rtems_task_create(
     Task_name[ 1 ],
     1,
     RTEMS_MINIMUM_STACK_SIZE,
     RTEMS_PREEMPT|RTEMS_NO_TIMESLICE|RTEMS_NO_ASR|RTEMS_INTERRUPT_LEVEL(0),
     RTEMS_DEFAULT_ATTRIBUTES,
     &Task_id[ 1 ]
  );
  directive_failed( status, "rtems_task_create of TA1" );

  status = rtems_task_create(
     Task_name[ 2 ],
     5,
     RTEMS_MINIMUM_STACK_SIZE,
     RTEMS_PREEMPT|RTEMS_NO_TIMESLICE|RTEMS_NO_ASR|RTEMS_INTERRUPT_LEVEL(0),
     RTEMS_DEFAULT_ATTRIBUTES,
     &Task_id[ 2 ]
  );
  directive_failed( status, "rtems_task_create of TA2" );

  status = rtems_task_create(
     Task_name[ 3 ],
     10,
     RTEMS_MINIMUM_STACK_SIZE,
     RTEMS_PREEMPT|RTEMS_NO_TIMESLICE|RTEMS_NO_ASR|RTEMS_INTERRUPT_LEVEL(0),
     RTEMS_DEFAULT_ATTRIBUTES,
     &Task_id[ 3 ]
  );
  directive_failed( status, "rtems_task_create of TA3" );

  status = rtems_task_create(
     Task_name[ 4 ],
     100,
     RTEMS_MINIMUM_STACK_SIZE,
     RTEMS_PREEMPT|RTEMS_NO_TIMESLICE|RTEMS_NO_ASR|RTEMS_INTERRUPT_LEVEL(0),
     RTEMS_DEFAULT_ATTRIBUTES,
     &Task_id[ 4 ]
  );
  directive_failed( status, "rtems_task_create of key" );

  status = rtems_task_start( Task_id[ 1 ], Task_1_through_3, 0 );
  directive_failed( status, "rtems_task_start of TA1" );

  status = rtems_task_start( Task_id[ 2 ], Task_1_through_3, 0 );
  directive_failed( status, "rtems_task_start of TA2" );

  status = rtems_task_start( Task_id[ 3 ], Task_1_through_3, 0 );
  directive_failed( status, "rtems_task_start of TA3" );

  status = rtems_task_start( Task_id[ 4 ], key, 0 );
  directive_failed( status, "rtems_task_start of key" );

  status = rtems_task_delete( RTEMS_SELF );
  directive_failed( status, "rtems_task_delete of RTEMS_SELF" );
}
