#include <stdio.h>
#include "system.h"

void adcRead(int taskNumber) {
    rtems_status_code status;

    printf("Task %i has entered adcRead.\n", taskNumber);

    status = rtems_semaphore_obtain(
        semaphoreId[adcLock],
	RTEMS_WAIT,
	RTEMS_NO_TIMEOUT
	);
    directive_failed(status, "rtems_semaphore_obtain");

    printf("Task %i has the converter.\n", taskNumber);

    status = rtems_semaphore_obtain(
        semaphoreId[adcWait],
	RTEMS_WAIT,
	RTEMS_NO_TIMEOUT
	);
    directive_failed(status, "rtems_semaphore_obtain");

    printf("Task %i has finished with the ADC.\n", taskNumber);
    status = rtems_semaphore_release(
        semaphoreId[adcLock]
	);
    directive_failed( status, "rtems_semaphore_release");
}

rtems_task Task_1_through_3(
  rtems_task_argument argument
)
{
  rtems_id          tid;
  rtems_status_code status;
  rtems_event_set   event_out;

  status = rtems_task_ident( RTEMS_SELF, RTEMS_SEARCH_ALL_NODES, &tid );
  directive_failed( status, "rtems_task_ident" );

  printf("Task %i has started.\n", task_number(tid));

  while( FOREVER ) {
    status = rtems_event_receive(
       RTEMS_EVENT_0,
       RTEMS_WAIT | RTEMS_EVENT_ANY,
       RTEMS_NO_TIMEOUT,
       &event_out
       );
    directive_failed( status, "rtems_event_recieve");
       
    adcRead(task_number(tid));
  }
}

rtems_task key(
  rtems_task_argument argument
  )
{
    rtems_id          tid;
    rtems_status_code status;

    char c;

    status = rtems_task_ident( RTEMS_SELF, RTEMS_SEARCH_ALL_NODES, &tid );
    directive_failed( status, "rtems_task_ident" );
    
    while( FOREVER ) {
	while ((c=getchar()))

	    /* change to switch */
	    if (c=='1' || c=='2' || c=='3' || c=='f')
		break;
	
	if (c=='f') {
	    printf("received f.\n");
	    asm("trap #2");
	}
	else {
	    printf("sending event to task %c.\n",c);
       
	    status = rtems_event_send(
	        Task_id[ (int)c-(int)'0' ],
		RTEMS_EVENT_0
		);
	    directive_failed( status, "rtems_event_send");
	}
    }
}
