/*  Init
 *
 *  This routine is the initialization task for this test program.
 *  It is a user initialization task and has the responsibility for creating
 *  and starting the tasks that make up the test.  If the time of day
 *  clock is required for the test, it should also be set to a known
 *  value by this function.
 *
 *  Input parameters:
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  init.c,v 1.5 1995/12/19 20:22:10 joel Exp
 */

#define TEST_INIT
#include "system.h"

rtems_task Test_task();
void size_rtems( int mode );

rtems_task Init(
  rtems_task_argument argument
)
{
  int choice;

  setvbuf(stdout, 0, _IONBF, 0);

  puts( "\n*** RTEMS SIZE PROGRAM ***" );
  size_rtems( 1 );
  puts( "*** END OF RTEMS SIZE PROGRAM ***" );
  exit( 0 );
#if 0
  do {
    printf( "\n\nPlease select program mode:\n" );
    printf( "  1) Print Formulas\n" );
    printf( "  2) Determine Workspace Size\n" );
    printf( "  3) Exit\n" );
    printf( "Enter number of choice (1,2,3) : " );

    choice = getint();
    switch( choice ) {
      case 1: size_rtems( 1 );  break;
      case 2: size_rtems( 0 );  break;
      case 3: exit( 0 );
      default:  continue;
    }
  } while ( FOREVER );
#endif
}
